package test;

import java.util.List;

import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.persistence.Cache;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;

@Stateless
@TransactionAttribute(TransactionAttributeType.REQUIRES_NEW)
public class MyBean {

    @PersistenceContext(unitName = "testPU")
    EntityManager em;

    public void read() {
        final TypedQuery<Dummy> namedQuery = this.em.createNamedQuery("Dummy.select", Dummy.class);
        final List<Dummy> results = namedQuery.getResultList();
        System.out.println(String.format("found %s records", results.size()));
    }

    public void evictCache() {
        final Cache cache = this.em.getEntityManagerFactory().getCache();
        cache.evictAll();
        System.out.println("Cache evicted.");
    }
}
